package java.text;

import java.util.ArrayList;

class CharacterIteratorFieldDelegate implements Format.FieldDelegate
{
    private ArrayList<AttributedString> attributedStrings;
    private int size;
    
    CharacterIteratorFieldDelegate() {
        this.attributedStrings = new ArrayList();
    }
    
    @Override
    public void formatted(Format.Field field, Object o, int i, int n, StringBuffer sb) {
        if (i != n) {
            if (i < this.size) {
                int size = this.size;
                int n2 = this.attributedStrings.size() - 1;
                while (i < size) {
                    AttributedString attributedString = (AttributedString)this.attributedStrings.get(n2--);
                    int n3 = size - attributedString.length();
                    int max = Math.max(0, i - n3);
                    attributedString.addAttribute(field, o, max, Math.min(n - i, attributedString.length() - max) + max);
                    size = n3;
                }
            }
            if (this.size < i) {
                this.attributedStrings.add(new AttributedString(sb.substring(this.size, i)));
                this.size = i;
            }
            if (this.size < n) {
                AttributedString e = new AttributedString(sb.substring(Math.max(i, this.size), n));
                e.addAttribute(field, o);
                this.attributedStrings.add(e);
                this.size = n;
            }
        }
    }
    
    @Override
    public void formatted(int n, Format.Field field, Object o, int n2, int n3, StringBuffer sb) {
        this.formatted(field, o, n2, n3, sb);
    }
    
    public AttributedCharacterIterator getIterator(String s) {
        if (s.length() > this.size) {
            this.attributedStrings.add(new AttributedString(s.substring(this.size)));
            this.size = s.length();
        }
        int size = this.attributedStrings.size();
        AttributedCharacterIterator[] array = new AttributedCharacterIterator[size];
        for (int i = 0; i < size; ++i) {
            array[i] = ((AttributedString)this.attributedStrings.get(i)).getIterator();
        }
        return new AttributedString(array).getIterator();
    }
}
